-- LCDTest.ex
-- LCD Test Program v2.0
-- Copyright (c) 2004 Samuel Loureno

without type_check

-- Include
include extra.e
include get.e
include graphics.e

-- Declare
constant COLORS = {RED, GREEN, BLUE}, SCREEN = 1
integer key, state
sequence flags

clear_screen()
text_color(BRIGHT_WHITE)
puts(SCREEN, "LCD Test Program v2.0\nCopyright (c) 2004 Samuel Loureno\n\n")
text_color(WHITE)
printf(SCREEN, "Keystrokes:\n%s LEFT - Shows previous screen according to a red-green-blue-ordered cycle.\n%s RIGHT - Shows next screen according to a red-green-blue-ordered cycle.\n", 7)
printf(SCREEN, "%s ENTER - Shows next undisplayed screen. If all screens were previously\ndisplayed then quits the program.\n%s CTRL+Q - Quits the program.\n\n", 7)
puts(SCREEN, "Press CTRL+Q to quit or ENTER to run test...")
while 1 do
    key = wait_key()
    if key = 13 then
        if graphics_mode(18) then
            puts(SCREEN, "\n\nError: Could not load 640 x 480, 16-colour pixel-graphics mode.\nPress any key to escape...")
            wait_any_key()
            clear_screen()
        else
            flags = {0, 0}
            state = 1
            while 1 do
                bk_color(COLORS[state])
                key = wait_key()
                if key = 13 then
                    if flags[1] = 0 then
                        state = 2
                    elsif flags[2] = 0 then
                        state = 3
                    else
                        exit
                    end if
                elsif key = 17 then
                    exit
                elsif key = 331 then
                    if state > 1 then
                        state -= 1
                    else
                        state = 3
                    end if
                elsif key = 333 then
                    if state < 3 then
                        state += 1
                    else
                        state = 1
                    end if
                end if
                if state > 1 and flags[state - 1] = 0 then
                    flags[state - 1] = 1
                end if
            end while
            def_graphics_mode()
        end if
        exit
    elsif key = 17 then
        clear_screen()
        exit
    end if
end while